/*
 * Factory.hh
 *
 *  Created on: Dec 11, 2010
 *      Author: lamikr
 */

#ifndef FACTORY_HH_
#define FACTORY_HH_

#include <string>
#include <list>

#include <dirent.h>

#include <plp/DeviceConfig.hh>
#include <plp/DataReader.hh>
#include <plp/Device.hh>

#ifndef W1_SCAN_ROOTDIR
	#define W1_SCAN_ROOTDIR		"/sys/bus/w1/devices"
#endif

namespace w1 {
	class Factory {
		public:
			Factory();
			virtual ~Factory();
			static std::list<plp::Device *> get_device_list();
		private:
			//int parse_family_code(string folder_name);
			static plp::Device *create_w1_device(int family_code_param, string device_type_param, string device_id_param, dirent *direntry_param);
			static plp::Device *create_w1_device(int family_code, string device_id, dirent *direntry_param);
			static plp::Device *create_w1_device(string device_type_param, string device_id_param);
			static plp::Device *create_w1_device(dirent *direntry_param, int *err_code_param);
			static std::list<plp::DataReader *> get_data_reader_list();
			static int get_family_code_by_device_type(string device_type_param);
			static string get_device_type_by_family_code(int family_code_param);
	};
}

#endif /* FACTORY_HH_ */
